#include <iostream>
#include <stdlib.h>
#include <vector>

using namespace std;

long long k, maxn, m;
vector < pair <long long, long long> > pairs;

long long GetRand64()
{
	long long a = rand();
	a <<= 16;
	a |= rand();
	a <<= 16;
	a |= rand();
	a <<= 16;
	a |= rand();
	if (a < 0) a = -a;
	return a;
}

int main(int argc, char** argv) {
	if (argc != 5) {
		cout << "gen_max_va.exe <K> <MaxN> <M> <RandSeed>";
		return 0;
	}
	k = atoi(argv[1]);
	maxn = atoi(argv[2]) - 1;
	m = atoi(argv[3]) - 1;
	long long randseed = atoi(argv[4]);
	srand(randseed);

	long long n = 1 << k;

	long long step = 1, size_of_step = 1;
	while (((step << 1) < maxn) && (step << 1 <= 1 << k)) step = step << 1;

	while (step > 0) {
		for(int i = 0; i < step * 2; i += 2) {
			if (pairs.size() == maxn) break;
			pairs.push_back(* new pair<long long, long long> (i * size_of_step + 1, (i + 1) * size_of_step + 1));
		}
		if (pairs.size() == maxn) break;
		size_of_step = size_of_step << 1;
		step = step >> 1;
	}
	
	long long shift = (1LL << (k - 1));

	cout << k << ' ' << pairs.size() + 1 << ' '<< m + 1 << endl;
	
	for(int i = 0; i < pairs.size(); i++)
		cout << shift + pairs[i].first << ' ' << shift + pairs[i].second << endl;

	int t = rand() + 1;
	cout << t << ' ' << t + 4 << endl;

	cout << t + 4;

	long long last = 0;
	for(int i = 0; i < m; i++) {
//		last += GetRand64() % ((1 << k) - last - (m - i - 1)) + 1;
		cout << " " << shift + i + 1;
//		cout << last << ' ';
	}

	cout << endl;

	return 0;
}