#include <iostream>
#include <fstream>
#include <cstdio>
#include <set>
#include <vector>
#include <ctime>
#include <cstdlib>
#include <algorithm>

using namespace std;

#define int64 long long

const int MUTATEPERCENT = 0;

int GetRand()
{
	int a = rand();
	a <<= 16;
	a |= rand();
	if (a < 0) a = -a;
	return a;
}

int64 GetRand64()
{
	int64 a = rand();
	a <<= 16;
	a |= rand();
	a <<= 16;
	a |= rand();
	a <<= 16;
	a |= rand();
	if (a < 0) a = -a;
	return a;
}

set<int64> wastriple;
vector<int64> killed1;
int n, k, m;
vector<int64> ask;
set<int64> wask;
vector<pair<int64, int64> > outedgs;

int main(int argc, char *argv[])
{
	int minn, maxn, mink, maxk, minm, maxm;
	mink = atoi(argv[1]);
	maxk = atoi(argv[2]);
	minn = atoi(argv[3]);
	maxn = atoi(argv[4]);
	minm = atoi(argv[5]);
	maxm = atoi(argv[6]);
	int seed;
	if (argc >= 7)
	{
		seed = atoi(argv[7]);
	}
	else seed = (int)time(NULL);
	srand(seed);
	n = GetRand() % (maxn - minn + 1) + minn;
	m = GetRand() % (maxm - minm + 1) + minm;
	k = GetRand() % (maxk - mink + 1) + mink;
	wastriple.clear();
	// generate some triples (type 1 or 2)
	int64 numpart = 1;
	numpart = numpart << k;
	int i;
	outedgs.clear();
	for (i = 0; i < n / 3; i++)
	{	
		int64 p = GetRand64() % numpart + 1;
		while (p % 4 != 0) p++;
		while (wastriple.find(p) != wastriple.end())
		{
			p = GetRand64() % numpart + 1;
			while (p % 4 != 0) p++;
		}
		if ((GetRand() % 2) == 0)
		{
			// type 1
			if (GetRand() % 100 > MUTATEPERCENT) outedgs.push_back(make_pair(p - 3, p - 2));
			if (GetRand() % 100 > MUTATEPERCENT) outedgs.push_back(make_pair(p - 3, p - 1));
			outedgs.push_back(make_pair(p - 3, p));
		}
		else
		{
			// type 2
			if (GetRand() % 100 > MUTATEPERCENT) outedgs.push_back(make_pair(p - 3, p - 2));
			if (GetRand() % 100 > MUTATEPERCENT) outedgs.push_back(make_pair(p - 1, p));
			outedgs.push_back(make_pair(p - 3, p - 1));
		}
		wastriple.insert(p);
		killed1.push_back(p - 3);
		killed1.push_back(p - 2);
		killed1.push_back(p - 1);
	}
	//output
	printf("%d %d %d\n", k, outedgs.size(), m);
	for (i = 0; i < outedgs.size(); i++)
	{
		printf("%I64d %I64d\n", outedgs[i].first, outedgs[i].second);
	}
	// generate m / 2 people killed in 1st or 2nd tour
	ask.clear();
	wask.clear();
	// killed
	for (i = 1; i <= m / 2; i++)
	{
		int pos = GetRand() % (killed1.size());
		while (wask.find(killed1[pos]) != wask.end())
		{
			pos = GetRand() % (killed1.size());
		}
		ask.push_back(killed1[pos]);
		wask.insert(killed1[pos]);
	}
	// any
	for (i = m / 2 + 1; i <= m; i++)
	{
		int64 num = GetRand64() % numpart + 1;
		while (wask.find(num) != wask.end())
		{
			num = GetRand64() % numpart + 1;
		}
		ask.push_back(num);
		wask.insert(num);
	}
	sort(ask.begin(), ask.end());
	for (i = 0; i < ask.size(); i++)
	{
		printf("%I64d ", ask[i]);
	}
	return 0;
}