#include <cstdio>
#include <vector>
#include <map>
#include <set>
#include <functional>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define forit(i, a) for (__typeof((a).begin()) i = (a).begin(); i != (a).end(); i++)
#define mp make_pair
#define pb push_back

typedef long long ll;

#define maxk 61
#define maxn 100010

int n, m, k;
map <ll, vector <ll> > c[maxk];
map <ll, int> res;
map < pair<int, ll>, set<ll> > v;

int GetTour( ll x, ll y )
{
  int res = 0;
  while (x != y)
    res++, x >>= 1, y >>= 1;
  return res - 1;
}

int main()
{
  freopen("topcoder.in", "r", stdin);
  freopen("topcoder.out", "w", stdout);

  scanf("%d%d%d", &k, &n, &m);

  forn(i, n)
  {
    ll x, y;
    scanf("%I64d%I64d", &x, &y);
    x--, y--;
    c[GetTour(x, y)][y].pb(x);
  }

  for (int i = 0; i < k; i++)
    forit(it, c[i])
    {
      ll y = it->first;
      set <ll> s = v[mp(i, (y >> i) ^ 1)];
      ll num = 1ll << i;

      int cnt = 0;
      vector <ll> vv = it->second;
      forn(j, vv.size())
        if (s.count(vv[j]))
          cnt++;
      if (s.size() + vv.size() - cnt == num)
      {
        if (!res.count(y))
          res[y] = i;
        for (int j = i + 1; j <= k; j++)
          v[mp(j, y >> j)].insert(y);
      }
    }

  forn(i, m)
  {
    ll a;
    scanf("%I64d", &a), a--;
    if (res.count(a))
      printf("%d ", res[a] + 1);
    else
      printf("%d ", k);
  }
  return 0;
}
